
void BtnInterrupt() 
{
    if(digitalRead(BUTTON_GameState) == pressed){
      if(millis()-check_debounce> 2*DEBOUNCE_DURATION ){
        Interrupt = true;
        check_debounce = millis();
      }
    }else{
      return;
  }}
// Generate apple / snake 
void game_new_apple_pos()
{
  bool validApple = true;
  do{
    applePos.x = rand()%GRAPHIC_WIDTH;
    applePos.y = rand()%GRAPHIC_HEIGHT;
    validApple = true;

      for(size_t i=0; i<snakeLength; i++)                                                                                                                                                                                                                           
    {
      if(applePos.x==snakePosHistory[i].x && applePos.y==snakePosHistory[i].y){
        validApple = false;
        break;
      }
    }
  } while(!validApple);

}
//Game logic + Display
void game_calculate_logic() {
  if(gameState!=GAME_PLAY) //Game over. Don't bother calculating game logic.
    return;

  //Calculate the movement of the tail
  for(size_t i=snakeLength; i>=1; i--){ //We intentionally use i=snakeLength instead of i=snakeLength-1 so that the snake will be lengthened right after it eats the apple
    snakePosHistory[i] = snakePosHistory[i-1];
  }
  //Calculate the head movement
  snakePosHistory[0]=snakePosHistory[1];
  switch(snakeDirection){
    case SNAKE_LEFT:  snakePosHistory[0].x--; break;
    case SNAKE_UP:    snakePosHistory[0].y--; break;
    case SNAKE_RIGHT: snakePosHistory[0].x++; break;
    case SNAKE_DOWN:  snakePosHistory[0].y++; break;
  }

  //Look for wall collision
  if(snakePosHistory[0].x<0||snakePosHistory[0].x>=GRAPHIC_WIDTH||snakePosHistory[0].y<0||snakePosHistory[0].y>=GRAPHIC_HEIGHT){
    gameState = GAME_LOSE;
    return;
  }

  //Look for self collision
  for(size_t i=1; i<snakeLength; i++){
    if(snakePosHistory[0].x==snakePosHistory[i].x && snakePosHistory[0].y==snakePosHistory[i].y){
      gameState = GAME_LOSE;
      return;
    }
  }

  if(snakePosHistory[0].x==applePos.x && snakePosHistory[0].y==applePos.y){
      snakeLength++;
      if(snakeLength<20){
      gameUpdateInterval = gameUpdateInterval*9/10;}
      else{
      gameUpdateInterval = gameUpdateInterval;}
      if(snakeLength>=sizeof(snakePosHistory)/sizeof(*snakePosHistory))
        gameState = GAME_WIN;
      else
        game_new_apple_pos();
  }
 
}
void game_calculate_display() {
  switch(gameState){
    case GAME_LOSE:
        Game_LOSE();
    break;
    case GAME_WIN:
       Game_WIN();
    break;
    case GAME_PLAY:
      Game_PLAY();
    break;
  }
}
// Game STATES
void Game_INIT(){
  srand(micros());
  gameState = GAME_PLAY;
  
  snakePosHistory[0].x=3; snakePosHistory[0].y=1;
  snakePosHistory[1].x=2; snakePosHistory[1].y=1;
  snakePosHistory[2].x=1; snakePosHistory[2].y=1;
  snakePosHistory[3].x=0; snakePosHistory[3].y=1;
  snakeLength = 4;
  snakeDirection = SNAKE_RIGHT;
  game_new_apple_pos();}

void Game_LOSE(){
  lcd.clear();
  lcd.setCursor(3, 0);
  lcd.print("You Lost !");
  lcd.setCursor(4, 1);
  lcd.print("Scor: ");
  lcd.setCursor(10, 1);
  Test_SnakeLength();
  lcd.print(snakeLength);}
  
void Game_MAIN(){
  lcd.begin(16, 2);
  lcd.setCursor(1, 0);
  lcd.print("Nistor Andreea");
  lcd.setCursor(3, 1);
  lcd.print("Snake Game");
  snakeLength = 0;
  hue = 359;
  setLedColorHSV(hue,1,0.7);}
  
void Game_WIN(){
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("You are Awsome");
  lcd.setCursor(0, 1);
  lcd.print("Scor: ");
  lcd.setCursor(8, 1);
  lcd.print(snakeLength);}

void Test_SnakeLength(){
  if(snakeLength<9)
    lcd.print(0);
}
void rgb_color(){
  switch(snakeLength){
    case 1 ... 5: hue = 120;
    break;
    case 6 ... 10 :hue = 220;
    break;
    case 11 ... 15: hue = 170;
    break;
    case 16 ... 20 :hue = 310;
    break;
    case 21 ... 25 :hue = 62;
    break;
  }
  setLedColorHSV(hue,1,0.7);
  }
void writeStringToEEPROM(int addrOffset, const String &strToWrite)
{
  byte len = strToWrite.length();
  EEPROM.write(addrOffset, len);
  for (int i = 0; i < len; i++)
  {
    EEPROM.write(addrOffset +1 + i, strToWrite[i]);
  }
}
String readStringFromEEPROM(int addrOffset)
{
  int newStrLen = EEPROM.read(addrOffset);
  char data[newStrLen + 1];
  for (int i = 0; i < newStrLen; i++)
  {
    data[i] = EEPROM.read(addrOffset + 1 + i);
  }
  data[newStrLen] = '\0'; // !!! NOTE !!! Remove the space between the slash "/" and "0" (I've added a space because otherwise there is a display bug)
  return String(data);
}

void Set_HighestScore(){
  if (a[0] <snakeLength){
     for(int i = 3;i>=1;i--){
      a[i] = a[i-1];
      }
     a[0] = snakeLength;
     Name4thPlace = Name3thPlace;
     Name3thPlace = Name2thPlace;
     Name2thPlace = Name1thPlace;
     Name1thPlace = setName;
  }
  else if (a[1] <snakeLength){
     for(int i = 3;i>=2;i--){
      a[i] = a[i-1];
      }
     a[1] = snakeLength;
     Name4thPlace = Name3thPlace;
     Name3thPlace = Name2thPlace;
     Name2thPlace = setName;
  }
  else if (a[2] <snakeLength){
     for(int i = 3;i>=3;i--){
      a[i] = a[i-1];
      }
     a[2] = snakeLength;
     Name4thPlace = Name3thPlace;
     Name3thPlace = setName;

 
  }
  else if (a[3] <snakeLength){
     a[3] = snakeLength;
     Name4thPlace = setName; 
  }
}
void Game_PLAY(){
  for(size_t i=0; i<snakeLength; i++)
        graphic_add_item(snakePosHistory[i].x, snakePosHistory[i].y, GRAPHIC_ITEM_A);
      graphic_add_item(applePos.x, applePos.y, GRAPHIC_ITEM_B);
      graphic_flush();}
      
void Game_CHECKHIGHSCORES(){
  lcd.clear();
  lcd.setCursor(0, 0);
  int maxNameChars = 0, currentChar = 0, charPosition = 12,currentNameWord=0;
  bool upDirection = false, downDirection = false;
 
    if(a[0]<snakeLength||a[1]<snakeLength||a[2]<snakeLength||a[3]<snakeLength){
      lcd.print("Ai obt highscore");
      lcd.setCursor(0,1);
      lcd.print("Enter Name:");
      do{
        
       if(digitalRead(BUTTON_UP) == pressed){
          if(debounce_activate_edge(&debCountBUTTON_UP)){
            if(downDirection){
            currentChar+=1;
            downDirection = false;}
            if(currentChar == sizeof(chars)){
              currentChar = 0;
            }
            lcd.setCursor(charPosition,1);
            lcd.print(chars[currentChar]);
            currentChar+=1;
            digitalWrite(BUTTON_UP,1);
            upDirection = true;}
      }else{
      debounce_deactivate(&debCountBUTTON_UP);}
      
      if(digitalRead(BUTTON_DOWN) == pressed){
          if(debounce_activate_edge(&debCountBUTTON_DOWN)){
            if(upDirection){
            currentChar-=1;
            upDirection = false;}
            if(currentChar == 0){
              currentChar = sizeof(chars);
            }
            lcd.setCursor(charPosition,1);
            currentChar-=1;
            lcd.print(chars[currentChar]);
            digitalWrite(BUTTON_DOWN,1);
            downDirection = true;}
      }else{
      debounce_deactivate(&debCountBUTTON_DOWN);}

      if(digitalRead(BUTTON_GameState) == pressed)
          return;

      
      if(digitalRead(BUTTON_RIGHT) == pressed){
          if(debounce_activate_edge(&debCountBUTTON_RIGHT)){
            currentChar -=1;
            setName[currentNameWord] = chars[currentChar];
            maxNameChars+=1;
            charPosition+=1;
            currentChar = 0;
            currentNameWord +=1;
            digitalWrite(BUTTON_RIGHT,1);}  
      }else{
      debounce_deactivate(&debCountBUTTON_RIGHT);}
      
       }while(maxNameChars<3);
    return;}
    else{
      lcd.print("Mai baga o fisa");
      return;}
  }
 
void Game_HIGHSCORES(){
  lcd.clear();
  lcd.setCursor(0, 0);
  
  for(int i = 0;i<4;i++){
    a[i] = EEPROM.read(i);
  }
  Name1thPlace =  readStringFromEEPROM(4);
  Name2thPlace =  readStringFromEEPROM(8);
  Name3thPlace =  readStringFromEEPROM(12);
  Name4thPlace =  readStringFromEEPROM(16);
  
  Set_HighestScore();
  
  for(int i = 0;i<4;i++){
    EEPROM.write(i,a[i]);
  }
  writeStringToEEPROM(4,Name1thPlace);
  writeStringToEEPROM(8,Name2thPlace);
  writeStringToEEPROM(12,Name3thPlace);
  writeStringToEEPROM(16,Name4thPlace);
  
  lcd.print("1-");
  lcd.print(Name1thPlace.substring(0,3));
   if(a[0]<=9)
    lcd.print(0);
  lcd.print(a[0]);
  lcd.print("|2-");
  lcd.print(Name2thPlace.substring(0,3));
  if(a[1]<=9)
    lcd.print(0);
  lcd.print(a[1]);
  lcd.setCursor(0,1);
  lcd.print("3-");
  lcd.print(Name3thPlace.substring(0,3));
  if(a[2]<=9)
    lcd.print(0);
  lcd.print(a[2]);
  lcd.print("|4-");
  lcd.print(Name4thPlace.substring(0,3));
  if(a[3]<=9)
    lcd.print(0);
  lcd.print(a[3]);
  }

      
