#include <LiquidCrystal.h>
#include <EEPROM.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
// Arduino initialize
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 10, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

enum DisplayItem {GRAPHIC_ITEM_NONE, GRAPHIC_ITEM_A, GRAPHIC_ITEM_B, GRAPHIC_ITEM_NUM};
enum {GAME_MENU, GAME_PLAY, GAME_LOSE, GAME_WIN, GAME_SCORES,GAME_NAMESCORE} gameState;
enum {SNAKE_LEFT,SNAKE_UP,SNAKE_RIGHT,SNAKE_DOWN} snakeDirection;


// initializare pini / valori
#define redPin A3
#define greenPin A4
#define bluePin A5
#define GRAPHIC_WIDTH 16
#define GRAPHIC_HEIGHT 4
#define BUTTON_GameState 3
#define BUTTON_UP 9
#define BUTTON_DOWN 8
#define BUTTON_RIGHT 7
#define BUTTON_LEFT 6
#define DEBOUNCE_DURATION 25
volatile bool Interrupt = false;
//variabile utile
bool pressed = false;
int a[4], hue, check_debounce;
String Name1thPlace,Name2thPlace,Name3thPlace,Name4thPlace;
const char chars[] = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
const int max_dimension = GRAPHIC_HEIGHT*GRAPHIC_WIDTH;
char setName[3];

byte block[3] = {
  B01110,
  B11111,
  B01110,
}; // corp snake

byte apple[3] = {
  B00100,
  B01110,
  B00100,
}; // corp applez

// Debounce values
unsigned long debCountBUTTON_GameState = 0,debCountBUTTON_RIGHT = 0,debCountBUTTON_LEFT = 0,debCountBUTTON_UP = 0,debCountBUTTON_DOWN = 0;

// Intialize positions
struct Pos {
  uint8_t x=0, y=0;
};
struct Pos applePos;
struct Pos snakePosHistory[max_dimension]; //first element is the head.
size_t snakeLength = 0;

// Intialize Game settings
unsigned long lastGameUpdateTick = 0;
unsigned long gameUpdateInterval = 850;
uint8_t graphicRam[GRAPHIC_WIDTH*2/8][GRAPHIC_HEIGHT];
